package org.bdware.consistency.plugin.pbft;

import com.google.gson.JsonObject;
import org.bdware.sc.conn.ByteUtil;
import org.bdware.sc.units.PubKeyNode;
import org.bdware.sc.units.TrustfulExecutorConnection;
import org.bdware.sdk.consistency.ConsistencyPluginManager;

import java.util.ArrayList;
import java.util.List;

public class ContractCluster implements TrustfulExecutorConnection<PubKeyNode> {
    private final List<PubKeyNode> members;
    String contractID;

    public ContractCluster(String contractID, List<PubKeyNode> members) {
        this.members = new ArrayList<>();
        this.members.addAll(members);
        this.contractID = contractID;
    }

    @Override
    public void sendMessage(PubKeyNode node, byte[] msg) {
        JsonObject jo = new JsonObject();
        jo.addProperty("action", "contractSyncMessage");
        jo.addProperty("contractID", contractID);
        jo.addProperty("data", ByteUtil.encodeBASE64(msg));
        ConsistencyPluginManager.getInstance().getContext().getNetworkManager().sendToAgent(node.pubkey, jo.toString());
    }

    @Override
    public List<PubKeyNode> getNodes() {
        return members;
    }
}
