package org.bdware.consistency.plugin.sharding;

import org.bdware.sc.bean.ContractExecType;
import org.bdware.sdk.consistency.api.ContractExecutorFactory;
import org.bdware.server.trustedmodel.ContractExecutor;

import java.util.Map;

public class MultiPointCooperationExecutorFactory implements ContractExecutorFactory {
    @Override
    public String getExecutorName() {
        return "Sharding";
    }

    @Override
    public ContractExecutor getInstance(Map<String, Object> args) {
        int nodeSize = (int) args.get("nodeSize");
        String contractID = (String) args.get("contractID");
        return new MultiPointCooperationExecutor(ContractExecType.Sharding, nodeSize, contractID);
    }
}
