#!/bin/bash
if [ $# -lt 1 ]; then
  echo "missing arguments,\nusage: \$version [-,push,save] \$saveDir"
  exit 1
fi
cp ./docker/AgentDockerfile ./agent-backend/build/output/Dockerfile
cd ./agent-backend/build
DOCKER_CLI_EXPERIMENTAL=enabled

if [ "$2" == "push" ]; then
  echo "push to docker hub"
  rm -rf ./output/BDWareProjectDir/public/TF*
  docker buildx build --platform linux/arm64/v8,linux/amd64 -t bdware/bdcontract:$1 ./ --push
elif [ "$2" == "save" ]; then
  echo "save to $3"
  rm -rf ./output/BDWareProjectDir/public/TFMac
  rm -rf ./output/WebContent/bdcontract4baas
  docker buildx build --platform linux/amd64 -t bdware/bdcontract:$1 ./ --load
  docker save -o $3/bdcontract-$1.tar bdware/bdcontract:$1
else
  echo "create at local"
  #  docker build  -t bdware/bdcontract-tf:$1 ./
  #  docker tag bdware/bdcontract-tf:$1 bdware/bdcontract-tf:latest
  rm -rf ./output/BDWareProjectDir/public/TFMac
  rm -rf ./output/WebContent/bdcontract4baas
  docker build -t bdware/bdcontract:$1 ./
  docker tag bdware/bdcontract:$1 bdware/bdcontract:latest
fi