#!/bin/bash
if [ ! -d "./BDWareProjectDir" ]; then
  mkdir ./BDWareProjectDir
fi
if [ ! -d "./ContractDB" ]; then
  mkdir ./ContractDB
fi

if [ ! -d "./ContractManagerDB" ]; then
  mkdir ./ContractManagerDB
fi

if [ ! -d "./log" ]; then
  mkdir ./log
fi

if [ ! -d "./manager.key" ]; then
  echo "missing manager.key! automatically generate!"
  java -cp cp/libs:cp/yjs.jar org.bdware.sc.SM2Helper generateKeyToFile
fi

if [ ! -d "./cp" ]; then
  echo "missing cp dir!"
  exit 1
fi

export CURDIR=`pwd`

docker run -p 21030:21030 -p 2641:2641 -p 2041:2041 -v $CURDIR/BDWareProjectDir:/bdcontract/BDWareProjectDir \
  -v $CURDIR/ContractDB:/bdcontract/ContractDB \
  -v $CURDIR/ContractManagerDB:/bdcontract/ContractManagerDB \
  -v $CURDIR/cmconfig.conf:/bdcontract/cmconfig.conf \
  -v $CURDIR/cp:/bdcontract/cp: \
  -v $CURDIR/keys:/bdcontract/keys: \
  -v $CURDIR/log:/bdcontract/log \
  -v $CURDIR/manager.key:/bdcontract/manager.key: \
  -d bdware/bdcontract:latest
